diff -uNr mythtv-0.21/programs/mythfilldatabase/xmltvparser.cpp mythtv/programs/mythfilldatabase/xmltvparser.cpp
--- mythtv-0.21/programs/mythfilldatabase/xmltvparser.cpp	2007-11-12 15:23:13.000000000 +0100
+++ mythtv/programs/mythfilldatabase/xmltvparser.cpp	2008-09-24 13:46:29.000000000 +0200
@@ -104,7 +104,7 @@
 {
     // we signal an error by setting it invalid (> 840min = 14hr)
     int result = 841;
-    
+
     if (timezone.upper() == "UTC" || timezone.upper() == "GMT")
         return 0;
 
@@ -299,12 +299,12 @@
     pginfo->endts = text;
 
     text = element.attribute("channel", "");
-    QStringList split = QStringList::split(" ", text);   
- 
+    QStringList split = QStringList::split(" ", text);
+
     pginfo->channel = split[0];
 
     text = element.attribute("clumpidx", "");
-    if (!text.isEmpty()) 
+    if (!text.isEmpty())
     {
         split = QStringList::split("/", text);
         pginfo->clumpidx = split[0];
@@ -416,9 +416,9 @@
             {
                 pginfo->previouslyshown = true;
 
-                QString prevdate = getFirstText(info);
+                QString prevdate = info.attribute("start");
                 pginfo->originalairdate = prevdate;
-            } 
+            }
             else if (info.tagName() == "credits")
             {
                 parseCredits(info, pginfo);
@@ -483,11 +483,11 @@
                 }
 
                 if (!partnumber.isEmpty())
-                {                
+                {
                     tmp = partnumber.toInt() + 1;
                     partnumber = QString::number(tmp);
                 }
-                
+
                 if (partnumber != 0 && parttotal >= partnumber && !parttotal.isEmpty())
                 {
                     pginfo->parttotal = parttotal;
@@ -506,7 +506,7 @@
 
     if (pginfo->category.isEmpty() && !pginfo->catType.isEmpty())
         pginfo->category = pginfo->catType;
-    
+
     /* Hack for teveblad grabber to do something with the content tag*/
     if (pginfo->content != "")
     {
@@ -515,7 +515,7 @@
             pginfo->subtitle = pginfo->desc;
             pginfo->desc = pginfo->content;
         }
-        else if (pginfo->desc != "") 
+        else if (pginfo->desc != "")
         {
             pginfo->desc = pginfo->desc + " - " + pginfo->content;
         }
@@ -524,13 +524,13 @@
             pginfo->desc = pginfo->content;
         }
     }
-    
+
     if (pginfo->airdate.isEmpty())
         pginfo->airdate = QDate::currentDate().toString("yyyy");
 
     /* Let's build ourself a programid */
     QString programid;
-    
+
     if (pginfo->catType == "movie")
         programid = "MV";
     else if (pginfo->catType == "series")
@@ -539,7 +539,7 @@
         programid = "SP";
     else
         programid = "SH";
-    
+
     if (!uniqueid.isEmpty()) // we already have a unique id ready for use
         programid.append(uniqueid);
     else
@@ -574,7 +574,7 @@
 
     return pginfo;
 }
-                  
+
 bool XMLTVParser::parseFile(
     QString filename, QValueList<ChanInfo> *chanlist,
     QMap<QString, QValueList<ProgInfo> > *proglist)
@@ -647,7 +647,7 @@
     while (!n.isNull())
     {
         QDomElement e = n.toElement();
-        if (!e.isNull()) 
+        if (!e.isNull())
         {
             if (e.tagName() == "channel")
             {
@@ -707,8 +707,8 @@
                             if (!aggregatedDesc.isEmpty())
                                 aggregatedDesc.append(" | ");
                             aggregatedDesc.append(pginfo->desc);
-                        }    
-                        if (pginfo->clumpidx.toInt() == 
+                        }
+                        if (pginfo->clumpidx.toInt() ==
                             pginfo->clumpmax.toInt() - 1)
                         {
                             pginfo->title = aggregatedTitle;
diff -uNr mythtv-0.21/programs/mythfrontend/globalsettings.cpp mythtv/programs/mythfrontend/globalsettings.cpp
--- mythtv-0.21/programs/mythfrontend/globalsettings.cpp	2008-03-08 00:14:05.000000000 +0100
+++ mythtv/programs/mythfrontend/globalsettings.cpp	2008-03-25 08:28:03.000000000 +0100
@@ -2264,7 +2264,7 @@
     for (int i=0; i<num; ++i)
         gc->addSelection(QString::number(i), QString::number(i));
     gc->addSelection(QObject::tr("All"), QString::number(-1));
-    gc->setLabel(QObject::tr("Xinerama screen"));
+    gc->setLabel(QObject::tr("Display on screen"));
     gc->setValue(0);
     gc->setHelpText(QObject::tr("Run on the specified screen or "
                     "spanning all screens."));
@@ -4885,9 +4885,7 @@
     VerticalConfigurationGroup* screen = new VerticalConfigurationGroup(false);
     screen->setLabel(QObject::tr("Screen settings"));
 
-    // These values are also used in non-Xinerama setups
-    // (e.g. Linux multi-head)
-    //if (GetNumberOfXineramaScreens() > 1)
+    if (GetNumberOfXineramaScreens() > 1)
     {
         screen->addChild(XineramaScreen());
         screen->addChild(XineramaMonitorAspectRatio());
diff -uNr mythtv-0.21/programs/mythfrontend/main.cpp mythtv/programs/mythfrontend/main.cpp
--- mythtv-0.21/programs/mythfrontend/main.cpp	2008-02-24 04:25:03.000000000 +0100
+++ mythtv/programs/mythfrontend/main.cpp	2009-04-19 23:30:15.000000000 +0200
@@ -58,6 +58,7 @@
 #include "mythscreenstack.h"
 #include "mythmainwindow.h"
 #include "mythappearance.h"
+#include "audiopulseutil.h"
 
 #define NO_EXIT  0
 #define QUIT     1
@@ -1321,6 +1322,10 @@
         }
     }
 
+    int pa_ret = pulseaudio_handle_startup();
+    if (pa_ret != GENERIC_EXIT_OK)
+        return pa_ret;
+
     if (logfile != "")
     {
         if (log_rotate(1) < 0)
@@ -1548,6 +1553,10 @@
     VERBOSE(VB_GENERAL, "Deleting UPnP client...");
     delete g_pUPnp;
 
+    pa_ret = pulseaudio_handle_teardown();
+    if (GENERIC_EXIT_OK != pa_ret)
+        return pa_ret;
+
     return FRONTEND_EXIT_OK;
 
 }
diff -uNr mythtv-0.21/programs/mythfrontend/mythfrontend.pro mythtv/programs/mythfrontend/mythfrontend.pro
--- mythtv-0.21/programs/mythfrontend/mythfrontend.pro	2008-02-04 10:00:43.000000000 +0100
+++ mythtv/programs/mythfrontend/mythfrontend.pro	2009-04-19 23:30:15.000000000 +0200
@@ -61,6 +61,7 @@
 using_xrandr:DEFINES += USING_XRANDR
 using_opengl_vsync:DEFINES += USING_OPENGL_VSYNC
 
+using_pulse:DEFINES += USING_PULSE
 using_alsa:DEFINES += USING_ALSA
 using_arts:DEFINES += USING_ARTS
 using_jack:DEFINES += USING_JACK
diff -uNr mythtv-0.21/programs/mythfrontend/playbackbox.cpp mythtv/programs/mythfrontend/playbackbox.cpp
--- mythtv-0.21/programs/mythfrontend/playbackbox.cpp	2008-02-27 06:12:15.000000000 +0100
+++ mythtv/programs/mythfrontend/playbackbox.cpp	2009-04-14 17:43:03.000000000 +0200
@@ -1059,14 +1059,14 @@
 
             // Centre preview in the y axis
             if (temp.height() < blackholeBounds.height())
-                pixmap_y = blackholeBounds.y() + 
+                pixmap_y = blackholeBounds.y() +
                                 (blackholeBounds.height() - temp.height()) / 2;
             else
                 pixmap_y = blackholeBounds.y();
 
             // Centre preview in the x axis
             if (temp.width() < blackholeBounds.width())
-                pixmap_x = blackholeBounds.x() + 
+                pixmap_x = blackholeBounds.x() +
                                 (blackholeBounds.width() - temp.width()) / 2;
             else
                 pixmap_x = blackholeBounds.x();
@@ -1191,14 +1191,14 @@
 
         // Centre video in the y axis
         if (img.height() < blackholeBounds.height())
-            video_y = blackholeBounds.y() + 
+            video_y = blackholeBounds.y() +
                             (blackholeBounds.height() - img.height()) / 2;
         else
             video_y = blackholeBounds.y();
 
         // Centre video in the x axis
         if (img.width() < blackholeBounds.width())
-            video_x = blackholeBounds.x() + 
+            video_x = blackholeBounds.x() +
                             (blackholeBounds.width() - img.width()) / 2;
         else
             video_x = blackholeBounds.x();
@@ -1679,7 +1679,7 @@
         paintSkipUpdate = false;
         update(drawTotalBounds);
     }
-    else 
+    else
     {
         progIndex = 0;
 
@@ -1701,7 +1701,7 @@
         paintSkipUpdate = false;
         update(drawTotalBounds);
     }
-    else 
+    else
     {
         int progCount = progLists[titleList[titleIndex].lower()].count();
 
@@ -1721,7 +1721,7 @@
 {
     if (inTitle)
         pageTop();
-    else 
+    else
     {
         progIndex = progLists[titleList[titleIndex].lower()].count() - 1;
 
@@ -2066,7 +2066,7 @@
         }
 
         ProgramInfo *p;
-        p = progLists[watchGroupLabel].first(); 
+        p = progLists[watchGroupLabel].first();
         while (p)
         {
             int recid = p->recordid;
@@ -2703,7 +2703,7 @@
         return false;
     }
 
-    if (rec->filesize == 0)
+    if ((rec->filesize == 0) && (rec->GetFilesize() == 0))
     {
         VERBOSE(VB_IMPORTANT,
             QString("PlaybackBox::play(): Error, %1 is zero-bytes in size")
@@ -3660,7 +3660,7 @@
         return;
 
     curitem->ForgetHistory();
-}    
+}
 
 void PlaybackBox::doJobQueueJob(int jobType, int jobFlags)
 {
diff -uNr mythtv-0.21/programs/mythshutdown/main.cpp mythtv/programs/mythshutdown/main.cpp
--- mythtv-0.21/programs/mythshutdown/main.cpp	2008-02-15 01:15:43.000000000 +0100
+++ mythtv/programs/mythshutdown/main.cpp	2008-09-18 19:55:35.000000000 +0200
@@ -74,12 +74,42 @@
 {
     VERBOSE(VB_GENERAL, "Mythshutdown: --lock");
 
-    QString value_str = getGlobalSetting("MythShutdownLock", "0");
-    bool isNumber = false;
-    ulong value = value_str.toULong(&isNumber);
-    if (!isNumber)
-        value = 0;
-    setGlobalSetting("MythShutdownLock", QString::number(++value));
+    MSqlQuery query(MSqlQuery::InitCon());
+
+    // lock setting table
+    int tries = 0;
+    while (!query.exec("LOCK TABLE settings WRITE;") && tries < 5)
+    {
+        VERBOSE(VB_GENERAL, "Waiting for lock on setting table");
+        sleep(1);
+        tries++;
+    }
+
+    if (tries >= 5)
+    {
+        VERBOSE(VB_GENERAL, "Waited too long to obtain lock on setting table");
+        return 1;
+    }
+
+    // does the setting already exist?
+    query.exec("SELECT * FROM settings "
+               "WHERE value = 'MythShutdownLock' AND hostname IS NULL;");
+
+    if (query.size() < 1)
+    {
+        // add the lock setting
+        query.exec("INSERT INTO settings (value, data) "
+                   "VALUES ('MythShutdownLock', '1');");
+    }
+    else
+    {
+        // update the lock setting
+        query.exec("UPDATE settings SET data = data + 1 "
+                   "WHERE value = 'MythShutdownLock' AND hostname IS NULL;");
+    }
+
+    // unlock settings table
+    query.exec("UNLOCK TABLES;");
 
     return 0;
 }
@@ -88,16 +118,44 @@
 {
     VERBOSE(VB_GENERAL, "Mythshutdown: --unlock");
 
-    QString value_str = getGlobalSetting("MythShutdownLock", "0");
-    bool isNumber = false;
-    ulong value = value_str.toULong(&isNumber);
-    if (!isNumber)
-        value = 0;
-    // Prevent going negative
-    if (value == 0)
-        ++value;
-    setGlobalSetting("MythShutdownLock", QString::number(--value));
+    MSqlQuery query(MSqlQuery::InitCon());
 
+    // lock setting table
+    int tries = 0;
+    while (!query.exec("LOCK TABLE settings WRITE;") && tries < 5)
+    {
+        VERBOSE(VB_GENERAL, "Waiting for lock on setting table");
+        sleep(1);
+        tries++;
+    }
+
+    if (tries >= 5)
+    {
+        VERBOSE(VB_GENERAL, "Waited too long to obtain lock on setting table");
+        return 1;
+    }
+
+    // does the setting exist?
+    query.exec("SELECT * FROM settings "
+               "WHERE value = 'MythShutdownLock' AND hostname IS NULL;");
+
+    if (query.size() < 1)
+    {
+        // add the lock setting
+        query.exec("INSERT INTO settings (value, data) "
+                   "VALUES ('MythShutdownLock', '0');");
+    }
+    else
+    {
+        // update lock setting
+        query.exec("UPDATE settings SET data = GREATEST(0,  data - 1) "
+                   "WHERE value = 'MythShutdownLock' AND hostname IS NULL;");
+    }
+
+    // unlock table
+    query.exec("UNLOCK TABLES;");
+
+    // tell the master BE to reset its idle time
     RemoteSendMessage("RESET_IDLETIME");
 
     return 0;
@@ -374,9 +432,7 @@
         if (add)
             restarttime = restarttime.addSecs((-1) * add);
 
-        QString wakeup_timeformat = gContext->GetSetting("WakeupTimeFormat",
-                                                            "yyyy-MM-ddThh:mm");
-        setWakeupTime(restarttime.toString(wakeup_timeformat));
+        setWakeupTime(restarttime.toString(Qt::ISODate));
 
         return true;
     }
@@ -881,6 +937,8 @@
     else
         showUsage();
 
+    delete gContext;
+
     return res;
 }
 
diff -uNr mythtv-0.21/programs/mythtranscode/mpeg2fix.h mythtv/programs/mythtranscode/mpeg2fix.h
--- mythtv-0.21/programs/mythtranscode/mpeg2fix.h	2006-10-13 16:47:28.000000000 +0200
+++ mythtv/programs/mythtranscode/mpeg2fix.h	2008-03-31 17:45:51.000000000 +0200
@@ -13,15 +13,15 @@
 extern "C"
 {
 //AVFormat/AVCodec
-#include "../libavcodec/avcodec.h"
-#include "../libavformat/avformat.h"
+#include "libavcodec/avcodec.h"
+#include "libavformat/avformat.h"
 
 //replex
 #include "replex/ringbuffer.h"
 #include "replex/multiplex.h"
 
 //libmpeg2
-#include "../libmythmpeg2/mpeg2.h"
+#include "libmythmpeg2/mpeg2.h"
 }
 
 enum MPFDisplayMask {
diff -uNr mythtv-0.21/programs/mythtranscode/transcode.cpp mythtv/programs/mythtranscode/transcode.cpp
--- mythtv-0.21/programs/mythtranscode/transcode.cpp	2008-03-08 01:07:31.000000000 +0100
+++ mythtv/programs/mythtranscode/transcode.cpp	2008-03-31 17:45:51.000000000 +0200
@@ -23,7 +23,7 @@
 #include "jobqueue.h"
 
 extern "C" {
-#include "../libavcodec/avcodec.h"
+#include "libavcodec/avcodec.h"
 }
 
 #define LOC QString("Transcode: ")
diff -uNr mythtv-0.21/programs/mythtv/main.cpp mythtv/programs/mythtv/main.cpp
--- mythtv-0.21/programs/mythtv/main.cpp	2008-02-24 14:58:52.000000000 +0100
+++ mythtv/programs/mythtv/main.cpp	2009-04-19 23:30:15.000000000 +0200
@@ -14,6 +14,7 @@
 #include "libmyth/mythdbcon.h"
 #include "libmyth/mythdialogs.h"
 #include "libmyth/compat.h"
+#include "audiopulseutil.h"
 
 #include <iostream>
 using namespace std;
@@ -251,6 +252,10 @@
     
     gContext->LoadQtConfig();
 
+    int pa_ret = pulseaudio_handle_startup();
+    if (pa_ret != GENERIC_EXIT_OK)
+        return pa_ret;
+
 #if defined(Q_OS_MACX)
     // Mac OS X doesn't define the AudioOutputDevice setting
 #else
@@ -287,7 +292,7 @@
         pginfo->isVideo = true;
 
         // RingBuffer doesn't like relative pathnames
-        if (filename.left(1) != "/" && !filename.startsWith("dvd://"))
+        if (filename.left(1) != "/" && !filename.startsWith("dvd:"))
             pginfo->pathname.prepend(QDir::currentDirPath() + '/');
     }
 
@@ -303,6 +308,10 @@
     }
     delete gContext;
 
+    pa_ret = pulseaudio_handle_teardown();
+    if (GENERIC_EXIT_OK != pa_ret)
+        return pa_ret;
+
     return TV_EXIT_OK;
 }
 
diff -uNr mythtv-0.21/programs/mythtv/mythtv.pro mythtv/programs/mythtv/mythtv.pro
--- mythtv-0.21/programs/mythtv/mythtv.pro	2007-09-05 18:58:55.000000000 +0200
+++ mythtv/programs/mythtv/mythtv.pro	2009-04-19 23:30:15.000000000 +0200
@@ -20,3 +20,18 @@
 }
 
 using_x11:DEFINES += USING_X11
+using_xv:DEFINES += USING_XV
+using_ivtv:DEFINES += USING_IVTV
+using_xvmc:DEFINES += USING_XVMC
+using_xvmc_vld:DEFINES += USING_XVMC_VLD
+using_xrandr:DEFINES += USING_XRANDR
+using_opengl_vsync:DEFINES += USING_OPENGL_VSYNC
+using_opengl_video:DEFINES += USING_OPENGL_VIDEO
+using_vdpau:DEFINES += USING_VDPAU
+
+using_pulse:DEFINES += USING_PULSE
+using_alsa:DEFINES += USING_ALSA
+using_arts:DEFINES += USING_ARTS
+using_jack:DEFINES += USING_JACK
+using_oss: DEFINES += USING_OSS
+macx:      DEFINES += USING_COREAUDIO
diff -uNr mythtv-0.21/programs/mythwelcome/welcomedialog.cpp mythtv/programs/mythwelcome/welcomedialog.cpp
--- mythtv-0.21/programs/mythwelcome/welcomedialog.cpp	2008-01-14 17:45:33.000000000 +0100
+++ mythtv/programs/mythwelcome/welcomedialog.cpp	2009-01-31 20:32:28.000000000 +0100
@@ -80,6 +80,7 @@
                          m_installDir + "/bin/mythfrontend");
 
     myth_system(startFECmd.ascii());
+    updateAll();
 }
 
 void WelcomeDialog::startFrontendClick(void)
@@ -378,8 +379,8 @@
                 status += "\n" + QDeepCopy<QString>(tuner->title);
                 if (!tuner->subtitle.isEmpty()) 
                     status += "\n("+QDeepCopy<QString>(tuner->subtitle)+")";
-                status += "\n" + tuner->startTime.toString("hh:mm") + 
-                          " " + tr("to") + " " + tuner->endTime.toString("hh:mm");
+                status += "\n" + tuner->startTime.toString(m_timeFormat) + 
+                          " " + tr("to") + " " + tuner->endTime.toString(m_timeFormat);
             }
             else
             {
@@ -414,7 +415,7 @@
 
             QString dateFormat = gContext->GetSetting("DateFormat", "ddd dd MMM yyyy");
             status += "\n" + prog->startTime.toString(dateFormat + " (" + m_timeFormat) +
-                " " + tr("to") + " " +  prog->endTime.toString("hh:mm)");
+                " " + tr("to") + " " +  prog->endTime.toString(m_timeFormat + ")");
 
             if (m_screenScheduledNo < m_scheduledList.count() - 1)
                 m_screenScheduledNo++;
diff -uNr mythtv-0.21/settings.pro mythtv/settings.pro
--- mythtv-0.21/settings.pro	2008-02-05 12:18:34.000000000 +0100
+++ mythtv/settings.pro	2009-04-19 23:30:15.000000000 +0200
@@ -3,6 +3,15 @@
 isEmpty( PREFIX ) {
     PREFIX = /usr/local
 }
+isEmpty( RUNPREFIX ) {
+    RUNPREFIX = $$PREFIX
+}
+isEmpty( LIBDIRNAME ) {
+    LIBDIRNAME = lib
+}
+isEmpty( LIBDIR ) {
+    LIBDIR = $${RUNPREFIX}/$${LIBDIRNAME}
+}
 
 LIBVERSION = 0.21
 VERSION = 0.21.0
@@ -88,8 +97,6 @@
 DEFINES += $$CONFIG_DEFINES
 DEFINES += _GNU_SOURCE
 DEFINES += _FILE_OFFSET_BITS=64
-DEFINES += PREFIX=\"$${PREFIX}\"
-DEFINES += LIBDIR=\"$${LIBDIR}\"
 
 # construct linking path
 LOCAL_LIBDIR_X11 =
@@ -109,6 +116,7 @@
 EXTRA_LIBS += $$CONFIG_AUDIO_ALSA_LIBS
 EXTRA_LIBS += $$CONFIG_AUDIO_ARTS_LIBS
 EXTRA_LIBS += $$CONFIG_AUDIO_JACK_LIBS
+EXTRA_LIBS += $$CONFIG_AUDIO_PULSE_LIBS
 EXTRA_LIBS += $$CONFIG_FIREWIRE_LIBS
 EXTRA_LIBS += $$CONFIG_DIRECTFB_LIBS
 
@@ -119,5 +127,6 @@
 EXTRA_LIBS += $$CONFIG_XVMC_LIBS
 EXTRA_LIBS += $$CONFIG_OPENGL_LIBS
 EXTRA_LIBS += $$FRIBIDI_LIBS
+using_pulse:EXTRA_LIBS += $$PULSE_LIBS
 
 LIRC_LIBS = $$CONFIG_LIRC_LIBS
diff -uNr mythtv-0.21/themes/themes.pro mythtv/themes/themes.pro
--- mythtv-0.21/themes/themes.pro	2008-01-29 03:24:25.000000000 +0100
+++ mythtv/themes/themes.pro	2008-04-24 04:19:34.000000000 +0200
@@ -7,6 +7,7 @@
 CONFIG -= moc qt
 
 !macx:QMAKE_COPY_DIR = sh ./cpsvndir
+win32:QMAKE_INSTALL_DIR = sh ./cpsvndir
 
 themes.path = $${PREFIX}/share/mythtv/themes/
 themes.files = blue defaultosd blueosd default default-wide G.A.N.T classic DVR
diff -uNr mythtv-0.21/version.pro mythtv/version.pro
--- mythtv-0.21/version.pro	2007-12-10 20:19:08.000000000 +0100
+++ mythtv/version.pro	2007-12-10 20:19:08.000000000 +0100
@@ -9,7 +9,7 @@
 MYTHBINVERS = $$system(egrep MYTH_BINARY_VERSION libs/libmyth/mythcontext.h | sed 's/.*MYTH_BINARY_VERSION //')
 
 SVNTREEDIR = $$system(pwd)
-SVNREPOPATH = "$$URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/version.pro $$"
+SVNREPOPATH = "$$URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/version.pro $$"
 
 
 SOURCES += version.cpp
